﻿#include "hmg.ch"

MEMVAR _HMG_SYSDATA

STATIC scTmpDir

FUNCTION Main()
  LOCAL aURL := { {"Eiffel Tower", "http://media.thisisinsider.com/images/58d919eaf2d0331b008b4bbd-960-720.jpg"}, ;
                  {"London Tower", "https://i2.wp.com/travelbluebook.com/wp-content/uploads/2016/02/Tower-of-London.jpg"}, ;
                  {"Pisa Tower",   "http://media1.britannica.com/eb-media/88/80588-004-0B5DCB41.jpg"}, ;
                  {"Taj Mahal",    "http://images.says.com/uploads/story_source/source_image/547108/2b63.jpg"}, ;
                  {"Tower Bridge", "http://www.goandco.co.uk/images/offices/tower-bridge.jpg"} }
  LOCAL n

  DEFINE WINDOW MainWnd;
    WIDTH  480 + GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/) * 2;
    HEIGHT 320 + GetSystemMetrics(4 /*SM_CYCAPTION*/) + GetSystemMetrics(8 /*SM_CYFIXEDFRAME*/) * 2;
    TITLE  "Image from website";
    MAIN;
    NOSIZE;
    NOMINIMIZE;
    NOMAXIMIZE;
    ON RELEASE HB_DirRemoveAll(scTmpDir)

    DEFINE LISTBOX PicLBox
      ROW         10
      COL         10
      WIDTH       150
      HEIGHT      267
      ONDBLCLICK  ImageView(aUrl, This.VALUE)
      ONGOTFOCUS  PostMessage(MainWnd.ViewButton.HANDLE, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
      ONLOSTFOCUS SendMessage(MainWnd.ViewButton.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
    END LISTBOX

    DEFINE BUTTON ViewButton
      ROW     287
      COL     10
      WIDTH   70
      HEIGHT  23
      CAPTION "View"
      ACTION  ImageView(aUrl, MainWnd.PicLBox.VALUE)
    END BUTTON

    DEFINE BUTTON SaveButton
      ROW     287
      COL     90
      WIDTH   70
      HEIGHT  23
      CAPTION "Save as"
      ACTION  ImageSaveAs(aUrl, MainWnd.PicLBox.VALUE)
    END BUTTON

    DEFINE IMAGE PicImage
      ROW     10
      COL     170
      WIDTH   300
      HEIGHT  300
      STRETCH .T.
    END IMAGE

    ON KEY ESCAPE ACTION MainWnd.RELEASE
  END WINDOW

  FOR n := 1 TO Len(aURL)
    MainWnd.PicLBox.AddItem(aURL[n][1])
  NEXT

  MainWnd.PicLBox.VALUE := 1

  MainWnd.CENTER
  MainWnd.ACTIVATE

RETURN NIL


FUNCTION ImageView(aUrl, nPos)
  LOCAL cTmpFile := ImageDownload(aUrl, nPos)

  IF ! Empty(cTmpFile)
    MainWnd.PicImage.PICTURE := cTmpFile
    MainWnd.PicImage.REDRAW
  ENDIF

RETURN NIL


FUNCTION ImageSaveAs(aUrl, nPos)
  LOCAL cExt := "." + HB_TokenGet(aURL[nPos][2], HB_TokenCount(aURL[nPos][2], "."), ".")
  LOCAL cTargetFile
  LOCAL cTmpFile

  cTargetFile := PutFile({{"*" + cExt, "*" + cExt}}, NIL, HB_CWD(), .F., aURL[nPos][1], cExt)

  IF ! Empty(cTargetFile)
    cTmpFile := ImageDownload(aUrl, nPos)

    IF ! Empty(cTmpFile)
      IF HB_fCopy(cTmpFile, cTargetFile) != 0
        MsgBox("Can not save file:" + CRLF + cTargetFile)
      ENDIF
    ENDIF
  ENDIF

RETURN NIL


FUNCTION ImageDownload(aUrl, nPos)
  LOCAL cExt := "." + HB_TokenGet(aURL[nPos][2], HB_TokenCount(aURL[nPos][2], "."), ".")
  LOCAL cTmpFile

  IF Empty(scTmpDir) .or. (! HB_DirExists(scTmpDir))
    scTmpDir := DirTmpCreate()
  ENDIF

  cTmpFile := scTmpDir + HB_NtoS(nPos) + cExt

  IF ! HB_FileExists(cTmpFile)
    IF ! URLDownloadToFile(aURL[nPos][2], cTmpFile)
      cTmpFile := ""
      MsgBox("Can not download image:" + CRLF + aURL[nPos][2])
    ENDIF
  ENDIF

RETURN cTmpFile


FUNCTION DirTmpCreate()
  LOCAL cTmpDir := GetTempDir()
  LOCAL cName   := HB_fNameName(GetProgramFileName())
  LOCAL nCount  := 0

  HB_DirBuild(cTmpDir)

  DO WHILE HB_fNameExists(cTmpDir + cName + "_" + HB_NtoS(nCount))
    ++nCount
  ENDDO

  HB_DirCreate(cTmpDir += cName + "_" + HB_NtoS(nCount) + "\")

RETURN cTmpDir


#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#include <Windows.h>
#include <urlmon.h>
#include "hbapi.h"

      // https://msdn.microsoft.com/en-us/library/ms775123(v=vs.85).aspx
      // URLDownloadToFile(cURL, cFile)
HB_FUNC( URLDOWNLOADTOFILE )
{
  HRESULT hr = URLDownloadToFile(NULL, HMG_parc(1), HMG_parc(2), 0, NULL);
  
  hb_retl(hr == S_OK);
}

#pragma ENDDUMP
